#ifndef _FileFormatDefs_H_
#define _FileFormatDefs_H_

//
// Map structs
//
typedef struct
{
	short wallptr, wallnum;
	long ceilingz, floorz;
	short ceilingstat, floorstat;
	short ceilingpicnum, ceilingheinum;
	signed char ceilingshade;
	char ceilingpal, ceilingxpanning, ceilingypanning;
	short floorpicnum, floorheinum;
	signed char floorshade;
	char floorpal, floorxpanning, floorypanning;
	char visibility, filler;
	short lotag, hitag, extra;
} sectortype;

typedef struct
{
	long x, y;
	short point2, nextwall, nextsector, cstat;
	short picnum, overpicnum;
	signed char shade;
	char pal, xrepeat, yrepeat, xpanning, ypanning;
	short lotag, hitag, extra;
} walltype;


typedef struct
{
	long x, y, z;
	short cstat, picnum;
	signed char shade;
	char pal, clipdist, filler;
	unsigned char xrepeat, yrepeat;
	signed char xoffset, yoffset;
	short sectnum, statnum;
	short ang, owner, xvel, yvel, zvel;
	short lotag, hitag, extra;
} spritetype;

typedef struct
{
	int x;
	int y;
	int z;
}Pos;

typedef struct
{
	unsigned int nVersion;
	Pos StartPosition;
	unsigned short nAngle;
	unsigned short nStartPointSecNum;
	unsigned short nNumSectors;
	sectortype sectors[1024];
	unsigned short nNumWalls;
	walltype walls[8192];
	unsigned short nNumSprites;
	spritetype sprites[4096];
}duke3dmap;


//
// Art structs
//
typedef struct
{
	uint16 tilesizex;
	uint16 tilesizey;
	uint32 picanm;
	uint8* data;
}TILESTRUCT;

//TODO: finish this struct
typedef struct
{
	unsigned long nVersion;
	unsigned long nNumTiles;
	unsigned long nTileStart;
	unsigned long nTileEnd;
	
	uint16 *tilesizex; //
	uint16 *tilesizey; // These are TEMP vaiables that should be null after init
	uint32 *picanm;    // TODO: remove the need for these to remain in the struct
	
	TILESTRUCT *tiles;
}ARTSTRUCT;

//
// GRP structs
//
typedef struct
{
	char name[12]; //remember, this excludes the \0 end character
	unsigned long int size;
}FILEHEADERSTRUCT;

typedef struct
{
	FILEHEADERSTRUCT fileheader;
	unsigned char* data;

}FILESTRUCT;

static const char* AuthorName = "KenSilverman";

//
// Palette structs
//
typedef struct
{
	uint8 palette[768];
	uint16 numpalookups;	
	uint8 (*palookup)[256]; //[numpalookups][256]
	uint8 transluc[256][256];

}PALETTESTRUCT;
	
#endif
